dnl -*- mode: html -*-
<html>
  <head>
    <link rel="SHORTCUT ICON" href="/favicon.ico">
    <title>merd's home page</title>
    <meta name="keywords" content="programming language, scripting, type inference, ML, OCaml, type classes, mix-ins, parametric polymorphism, open world types, structural equivalence, soft-typing, type-indexed rows, overloading, multi-method, subtyping, bounded quantification, union types, first-class types, WYSIHIIP, indentation based grouping, staged computation, free software">
  </head>
<body text="#f5deb3" link="#f5de83" alink="#b3ae71" vlink="#b3ae71" bgcolor="#2f4f4f">

<table width="100%"><tr><td>

<blockquote>
merd =
<br>&nbsp; &nbsp; <a href="http://www.ruby-lang.org/">Ruby</a>-like expressivity +
<br>&nbsp; &nbsp; static type checks (a la <a href="http://www.haskell.org">Haskell</a>)
</blockquote>

</td><td align=right><a href="THANKS.html"><img border=0 src="merd-logo.png"
alt=""></a></td></tr>
</table>

<ul>
<li><a href="#resources">Resources</a>
<li><a href="#features">Features</a>
<li><a href="#examples">Examples</a>
<li><a href="#wyal">Why Yet Another Language</a>
<li><a href="#download">Download</a>
<li><a href="faq.html">FAQ</a>
</ul>

<!-- ------------------------------------------------------------------------------->
<hr><h1><a name="resources">Resources</a></h1>
<a href="http://lists.sf.net/mailman/listinfo/merd-devel">merd-devel</a> is the mailing list about merd development.
<p>
A forum and various stuff is provided by
<a href="http://sf.net/projects/merd/"><img src="http://sourceforge.net/sflogo.php?group_id=10264" height=31 border=0 alt="sourceforge"></a>.

<p>
Like all good free software, merd is in CVS :)
You can access browse it using <a href="http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/merd/merd/">viewcvs</a>

<br>see <a href="https://sourceforge.net/cvs/?group_id=10264">sourceforge CVS help</a> for more

<!-- ------------------------------------------------------------------------------->
<hr><h1><a name="features">Features</a></h1>

<ul><li>function/method calling
<ul>
<li><a href="polymorphism.html">parametric and ad'hoc polymorphism</a> (overloading/refining/specializing)
<li>late binding
<li>default parameters
</ul>

<li><a href="types.html">types</a>
<ul>
<li>strongly typed
<li>static typing (keeping expressivity!)
<li>type inference (see ML, and more precisely <a href="http://www.cs.chalmers.se/~nordland/ohaskell/">O'Haskell</a>)
<li><a href="http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/~checkout~/merd/merd/docs/subtyping.me?content-type=text/plain">subtyping</a> (extendable structs, extendable datatype, subranges, bounded quantification...)
<li>abstract-types (mix-in's, aka type-classes)
<li>types as first-class citizen
</ul>

<li>functional programming
<ul>
<li>functions as first-class citizen (even overloaded one)
<li>anonymous functions
<li>partial application
</ul>

<li><a href="choices_syntax.html">sugaring</a>
<ul>
<li>user definable operators (infix, prefix, suffix, multi-op, around-op)
<li>OO-like syntax (purely syntactic)
<li><a href="http://www.cs.man.ac.uk/~pjj/cs2112/langdes/indent.html">indentation based grouping</a> (see haskell&python), also called layout
<li>horizontal layout:  <tt>1+2 * 3</tt>  is  <tt>(1+2) * 3</tt>    (merd innovation!)
<li>pattern-matching (see ML)
<li>macros (?)
</ul>
<li><a href="http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/~checkout~/merd/merd/lib/classes.me?content-type=text/plain">extensible powerful library</a>
(<a href="http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/~checkout~/merd/merd/lib/libs.me?content-type=text/plain">work in progress</a>,
<a href="http://merd.net/pixel/language-study/syntax-across-languages.html">inspired by many languages especially ruby</a>)

<!--
<li>implementation
<ul>
<li>garbage collector (mark & sweep?)
<li>reflexivity
</ul>
-->
<li><a href="choices.html">various choices explained</a>

</ul>

<!-- ------------------------------------------------------------------------------->
<hr><h1><a name="examples">Examples</a></h1>

<ul>
<li><a href="cookbook.html">A lot of examples taken from the Perl Cookbook</a>
(<a href="http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/~checkout~/merd/merd/examples/cookbook.me?content-type=text/plain">flat file</a>)
<li>Various examples:

<font size="+1">
<pre>
<font color="#ff0000">##########
</font>fact <font color="#ffa500">:=</font> 
    <font color="#cdcd00">0</font> <font color="#ffa500">-&gt;</font> <font color="#cdcd00">1</font>
    n <font color="#ffa500">-&gt;</font> n * <font color="#b2dfee">fact</font><font color="#00ffff">(</font>n-<font color="#cdcd00">1</font><font color="#00ffff">)</font>

<font color="#b2dfee">fact'</font><font color="#00ffff">(</font>n<font color="#00ffff">)</font> <font color="#ffa500">:=</font> <font color="#ffa500">if</font> n <font color="#b0c4de">==</font> <font color="#cdcd00">0</font> <font color="#ffa500">then</font> <font color="#cdcd00">1</font> <font color="#ffa500">else</font> n * <font color="#b2dfee">fact'</font><font color="#00ffff">(</font>n-<font color="#cdcd00">1</font><font color="#00ffff">)</font>

<font color="#b2dfee">fact''</font><font color="#00ffff">(</font>n<font color="#00ffff">)</font> <font color="#ffa500">:=</font> 
    fact <font color="#b0c4de">=</font> <font color="#cdcd00">1</font>
    <font color="#ffa500">while</font> n &gt; <font color="#cdcd00">0</font> <font color="#ffa500">do</font> 
        fact *<font color="#b0c4de">=</font> n
        n--
    fact

<font color="#ff0000">##########
# overloading
</font>
print <font color="#b0c4de">=</font> print_int
print <font color="#b0c4de">=</font> print_string
<font color="#00ffff">[</font> <font color="#cdcd00">1</font><font color="#b0c4de">,</font> <font color="#00cd00">&quot;a&quot;</font> <font color="#00ffff">]</font><font color="#b0c4de">.</font><font color="#b2dfee">map</font><font color="#00ffff">(</font>print<font color="#00ffff">)</font>

<font color="#ff0000">##########
# Lazy parameters
</font>
a &amp;&amp; <font color="#ff00ff">Lazy</font><font color="#00ffff">(</font>b<font color="#00ffff">)</font> <font color="#b0c4de">=</font> <font color="#ffa500">if</font> a <font color="#ffa500">then</font> b <font color="#ffa500">else</font> <font color="#ff00ff">False</font>
a || <font color="#ff00ff">Lazy</font><font color="#00ffff">(</font>b<font color="#00ffff">)</font> <font color="#b0c4de">=</font> <font color="#ffa500">if</font> a <font color="#ffa500">then</font> <font color="#ff00ff">True</font> <font color="#ffa500">else</font> b

<font color="#ff00ff">Lazy</font><font color="#00ffff">(</font>a<font color="#00ffff">)</font> <font color="#ffa500">or</font> <font color="#ff00ff">Lazy</font><font color="#00ffff">(</font>b<font color="#00ffff">)</font> <font color="#ffa500">:=</font> <font color="#ffa500">try</font> a <font color="#ffa500">with</font> _ <font color="#ffa500">-&gt;</font> b

<font color="#b2dfee">before_leaving</font><font color="#00ffff">(</font><font color="#ff00ff">Lazy</font><font color="#00ffff">(</font>f<font color="#00ffff">)</font><font color="#b0c4de">,</font> <font color="#ff00ff">Lazy</font><font color="#00ffff">(</font>f2<font color="#00ffff">))</font> <font color="#b0c4de">=</font>
    <font color="#ffa500">try</font> v <font color="#b0c4de">=</font> f2 <font color="#00ffff">;</font> f <font color="#00ffff">;</font> v
    <font color="#ffa500">with</font> e <font color="#ffa500">-&gt;</font> f <font color="#00ffff">;</font> <font color="#ffa500">raise</font> e

<font color="#b2dfee">local</font><font color="#00ffff">(</font>expr<font color="#b0c4de">,</font> val<font color="#b0c4de">,</font> <font color="#ff00ff">Lazy</font><font color="#00ffff">(</font>f<font color="#00ffff">))</font> <font color="#b0c4de">=</font>
    old <font color="#b0c4de">=</font> expr
    expr <font color="#b0c4de">=</font> val
    <font color="#b2dfee">before_leaving</font><font color="#00ffff">(</font>f<font color="#b0c4de">,</font> expr <font color="#b0c4de">=</font> old<font color="#00ffff">)</font>

<font color="#ff0000">##########
# Partial application
</font>
<font color="#b2dfee">map</font><font color="#00ffff">(</font><font color="#b0c4de">,</font>f<font color="#00ffff">)</font> <font color="#b0c4de">=</font>
    <font color="#00ffff">[]</font> <font color="#ffa500">-&gt;</font> <font color="#00ffff">[]</font>
    e<font color="#b0c4de">:</font>l <font color="#ffa500">-&gt;</font> <font color="#b2dfee">f</font><font color="#00ffff">(</font>e<font color="#00ffff">)</font> <font color="#b0c4de">:</font> l<font color="#b0c4de">.</font><font color="#b2dfee">map</font><font color="#00ffff">(</font>f<font color="#00ffff">)</font>

double_list <font color="#b0c4de">=</font> <font color="#b2dfee">map</font><font color="#00ffff">(</font><font color="#b0c4de">,</font> <font color="#cdcd00">2</font> *<font color="#00ffff">)</font>
<font color="#00ffff">[</font><font color="#cdcd00">1</font><font
color="#b0c4de">,</font><font color="#cdcd00">2</font><font
color="#00ffff">]</font><font color="#b0c4de">.</font><font
color="#b2dfee">double_list</font> <font color="#ff0000">#=&gt; [2,4]
</font>
</pre>
</font>
</ul>



<!-- ------------------------------------------------------------------------------->
<hr><h1><a name="wyal">Why Yet Another Language</a></h1>

<h2>Dynamic Languages</h2>
The language I really miss is alike Ruby: very usable with nice default
library. The success of Perl/Python/Ruby is partly due to their data
structures, especially lists/arrays, hashes and strings.
Alas, they miss static checks, Ruby being a dynamically typed languages, very
few checks are done at compile-time, making medium to big programs hard to
maintain.
<p>

As far as I know, few dynamically typed languages try to achieve compile-time
type checks on the overall program. The typical orientation is adding type
annotations (mainly for speedups and run-time checks). Dylan is an example of
mixing dynamic typing and explicit typing.
<p>

<a href="http://citeseer.nj.nec.com/cartwright91soft.html"><em>Soft Typing</em></a>
designates the effort of using type inference for dynamic languages.
Alas dynamic languages have a lot of features making it hard to infere types:
<ul>
<li>heterogeneous data structures (it simplifies the language, the type declaration, no datatypes)
<li>incremental compilation/loading of packages
<li>ability to create function/methods at runtime
<li>use of the same variable with values of different types
<li>return values ignored (pb inherited from Algol68, useful when return value is not highly valued (error code...))
</ul>

<h2>Static Languages</h2>

Compared to dynamic languages, statically typed languages are usually less
expressive or much more complicated:
<ul>
<li>Explictly typed languages have the burden of giving the type of
everything. 
<p>Type inference based languages (Haskell, OCaml) regain some of the
expressivity. But they usually loose some overloading capabilities (OCaml has
no overloading, Haskell has no ad'hoc overloading)
<p>
<li>Type declarations are needed
<li>Type reflexion needed to typecheck "printf"-like functions in a general
way (<a href="http://www.cs.chalmers.se/~augustss/cayenne/">Cayenne</a>)
<li>Genericity is harder to obtain (eg: missing in Java, templates in C++)
<!--
<li>Some research has been done to mix compile-time type checking with types known
at run-time (<em>Dynamic</em> types in
<a href="http://citeseer.nj.nec.com/313297.html">ML</a> and
<a href="http://citeseer.nj.nec.com/shields97dynamic.html">haskell</a>).
-->
</ul>
<p>
Is this expressiveness loss too much? unavoidable?

  <h3><a href="merd-vs-others.html#Haskell">Haskell</a></h3>

Haskell can hardly play in the dynamic languages ground due to its lazyness.
The transition between imperative to monads is a too big step.

  <h3><a href="merd-vs-others.html#OCaml">OCaml</a></h3>

OCaml <strong>is</strong> a serious player with a lot of features:
<ul>
<li>functional, OO and imperative programming
<li>good & fast interpreter + compiler + debugger
<li>polymorphic variants (enabling lightweight types and variant subtyping)
</ul>
<p>
Alas, some bad points makes it badly suited for scripting
<ul>
<li>no overloading (eg: "+." for floating point numbers, List.length vs Array.length)
<li>default library
  <ul>
  <li>poor string functions, no good default regexp
  <li>dictionnary (hash) not sugared enough
  <li>too big separation between lists and arrays
  <li>no overloading
  </ul>
<li>no string interpolation (like perl "foo is $foo" or ruby "foo is #{foo}")
<li>uncommon syntax (especially for imperative programming and OO)
<li>no data inheritance (only interface inheritance)
<li>elusive syntax error messages
<li>bad polymorphic variants error messages
</ul>

<p>
Most bad points above do not need changing the language, or only a few
extensions. For example 
<a href="http://pauillac.inria.fr/~furuse/generics/">G'Caml</a> gets rid of
the lack of overloading. <a href="http://caml.inria.fr/camlp4/">Camlp4</a>
brings some solution to the syntax problems.

<br>
But I think OCaml is already too big a language to add new features.

<h2>Innovations</h2>

<ul>
<li>try to fill the expressivity gap between the static typing world and the
dynamic typing world.
<li><a href="types.png">clean core of values</a>: datatypes, structs, abstract
types, functions, numbers...
<li><a href="polymorphism.html">clean & complete overloading</a>
(overloaded functions are first class)
<li><a href="http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/~checkout~/merd/merd/docs/subtyping.me?content-type=text/plain">structural equivalence and <em>open world</em> types</a>
  <ul>
  <li>try hard to keep the more precise types
     <br><tt> &nbsp; [ 1, "foo" ] !! [ 1 | "foo" ] </tt>
     <br> means the type of list <tt>[ 1, "foo" ]</tt> is a list of elements of type <tt>1|"foo"</tt>
  <li>existential-like types with subtyping: 
     <br><tt> &nbsp; [x,y] !! [Int|String]</tt> with <tt>x !! Int ; y !! String</tt>
     <br>means type of list <tt>[x,y]</tt> is a list of elements of type <tt>Int|String</tt>
     <br><tt> &nbsp; [ 1, "foo" ].map(+ 1)</tt> is ill-typed, but
     <br><tt> &nbsp; [ 1, "foo" ].map(+ 1|&|"bar")</tt> gives <tt>[ 2, "foobar" ]</tt>
  <li>even abstract types are structural equivalence based.
  <li>try avoiding the haskell Int vs Integer disease:
  <br><tt>getStdRandom(randomR(1, 2))</tt> fails with "Unresolved top-level overloading".
  <br>One solution is to allow a preferred type.
  <li>use names only for error messages (and try <strong>very</strong> hard to
  find the best names, since for error messages cost is not important)
  </ul>
<li>staged evaluation: execute at compile-time what's possible. This permits
to do some of the classical preprocessor work 
(see <a href="http://pliant.cx/">pliant</a> for a real life example, C++
templates also have the same power)
</ul>

<h2><a name="slides">Slides</a></h2>

Here is <a href="slides">a small presentation</a> (generated with <a href="http://www.mew.org/mgp/">MagicPoint</a> from this <a href="slides.mgp.m4">file</a>)


<!-- ------------------------------------------------------------------------------->
<hr><h1><a name="download">Download</a></h1>

<b>THIS IS PRE-ALPHA SOFTWARE. DO NOT EXPECT *ANYTHING*</b>
<p>
Current version is VERSION.
<ul>
<li><a href="merd-VERSION.tar.bz2">Source tarball</a>
<li><a href="merd-VERSION-1mdk.i586.rpm">binary rpm</a>
<li><a href="merd_`'VERSION-1_i386.deb">binary deb</a>
</ul>

<hr>
<address><a href="mailto:pixel@merd.net">Pixel</a></address>
$Id: index.html.m4,v 1.10 2002/05/10 10:48:54 pixel_ Exp $

<p><A HREF="http://www.estat.com/getstats?serial=1400113423"><IMG SRC="http://perso.estat.com/cgi-bin/perso/1400113423?page=merd" BORDER=0></A>

</body>
</html>

