$string_interpolation = 
[
 'merd has string interpolation' =>
q(This feature may seems like a gadget, but script programming use it very often),
];

$temporary_value =
[

q(Perl's "local", Scheme's "fluid-let" and Haskell's implicit variables
allows to set a variable temporarily. This is easily introduced is merd.
This construct replaces the saving of the old value and its restoration
(with taking care of exceptions!)
),

];

$character_is_string =
[

q(In Perl and Python, there is no character value. The functions that usually
work on characters like "ord(c)" await a string of length 1.),

q(In merd, Builtin::Char is a subtype of Builtin::String. It means you can use
a character where a string is needed, but not the contrary.),

];

$keeping_variable_names_in_types =
[
q(The type of "fst" is "x, _ -> x" 
 instead of "a, b -> a" in Haskell 
 and "'a * 'b -> 'a" in OCaml
),
];


$all = [

Perl => [

[ 'Perl inspiring merd' =>

  [ 'perldiag' =>

  q(Perl's diagnose messages in case of problems are great. They usually
  suggest how to fix the problem. merd will try to follow this trend. As an
  example, merd could suggest the use "xxx!" instead of "xxx" when the return
  value is ignored and "xxx!" exists. ),
  
  ],

  [ '"local" on structures' =>
    @$temporary_value,
    q(merd doesn't have Perl's inability to local'ize local (lexical) variables),
  ],

  [ '"or"-like' =>

    q(in merd, "or" doesn't work on booleans the way it does in perl. But
merd's "or" is used alike perl's.),
    q(In "a or b", instead of testing the truth
value of "a", it catches any exception "a" raise. If no exception is
raised, "a" is returned. Otherwise, the exception is caught and "b" is
executed.),

  ],

  [ 'object destruction time predictable/reproducible/ASAP' =>
    'region-based inference permits this on non-incremental garbage collectors' ],

  [ 'full featured lists/arrays' => 'push, pop, indexing, adding... available' ],

  [ 'a character is a string of length 1' => @$character_is_string ],

  [ '"if" infix' ],
  [ 'regexp syntax and semantics' ],
  [ '"/" on integers returns a float/bigrat (Haskell does this too)' ],
  [ 'non-mutable strings' ],
  [ 'tuples are lists' ],

  [ 'default value used when increasing the size of an array' ],
],

[
'merd is more polymorphic' => '"==" and "+" works on many types',
],

[ 'merd has no list auto-flattening by default' =>
q(auto-flattening makes complicate data strutures harder to use/think-about),
],

[ 'merd has no $_, $1, $a' =>
'but still expressive thanks to:' =>
  [ 'low syntax overhead on anonymous functions' ],
  [ 'partial application' ],
],

[ 'regexp usage is different in merd' =>
'regexps are statically type checked in merd. There is no $1 global variables',
],

[ '<a href="choices.html#strings">iterating and indexing strings</a>' =>

  q(in Perl, you need to do "split //, $string" to get a list of characters ;
whereas in merd you can use "each" directly on a string. Just like in Perl,
you can't directly index a string, this being a bad habit. In both Perl and
merd strings are immutable.),

],

[ 'merd has named function parameters' ],
[ 'merd has a builtin hash keeping the order' ],
[ 'merd has a simpler core syntax' ],
[ 'merd has a cleaner IO syntax' ],
[ 'no wantarray in merd, but return value overloading available' ],
[ 'merd has structs' ],
[ 'merd has multi-methods' ],
[ 'lists in merd are not tuples' ],

],

Python => [

[ 'Python inspiring merd' =>
  [ 'a character is a string of length 1' => @$character_is_string ],
],

[ 'merd is more functional programming friendly' =>
  'Why? because in Python:' =>
[ q(sort is in-place) ],
[ q(lambda is restricted to expressions, disallowing statements) ],
[ q(if_then_else is a statement, and there's no "? :" ternary operator) ],
],
[ 'merd has a cleaner (more polymorphic) basic library' ],
[ 'merd has more errors detected at compile-time',
q(Python does close to no checks. PyChecker can only find local, mostly syntaxical errors.),
 ],
[ 'merd favours data copying where python favours data sharing',
  'merd also provides data sharing using inoutness inference',
  'python is not consistent: it does not allow easy sharing of its builtin types',
],
[ 'python has better runtime reflexivity support',
  '(merd could have some using some "Unsafe" tag)',
],
[ 'merd has multi-methods' =>
  'especially nice for the specialization of "+", "=="',
],

[ '<a href="choices.html#strings">iterating and indexing strings</a>' =>

  q(in Python, you can both iterate and index a string. In merd, you can use
"each" to iterate on a string, but you can't index a string. In both Perl and
merd strings are immutable.),

],

[ "merd nicely integrates regexp matching" ],

[ 'python has lists comprehension' ],
[ 'python can use the same variables with different types' ],

[ 'merd has pattern matching a la ML' ],
],

OCaml => [
q(
Quite generally, OCaml suffers from an expressivity problem when it comes to
script-like programming.
),

[ 'merd has mix-ins overloading' =>

 q(in OCaml, "length" is either "Array.length" or "List.length" or
"String.length". You have to choose which one you want. This limits polymorphism.

Another OCaml syntax weirdness is "+." which works on floats.
),
], 

$string_interpolation, 

[ 'merd blurs lists and arrays' =>

q(When you are using a list, it doesn't mean you don't need indexing.
Conversely you sometimes need to remove some elements in an array. Scripting
languages (perl...) have blurred lists and arrays successfully (in term of
expressivity). In merd, you can switch easily from an list implementation to
an array implementation. One could even dream of an optimizing compiler which
would make the choice on its own... ),
],

[ 'integer overflow' =>

q(OCaml tries hard to detect everything at compile-time, and if it can't, it
signals at runtime... except for numerical operations where overflowing is
simply ignored. In merd, the default is to use bignums and bigrats which can't
overflow (nor underflow). And for Int's which can overflow, merd will raise an
exception when it occurs. There may be a flag to disable this verification for
the sake of speed, at the price of safeness (just like OCaml's "-unsafe" option)

),

],

[ 'OCaml syntax error messages can be elusive' =>

q(The various constructs in OCaml permits to rarely use explicit block
delimiters. The drawback occurs when something is wrong: the syntax richness
tends to get in the way, especially when programming imperatively.),

],

[ 'OCaml has bad polymorphic variants error messages' =>

q(Since OCaml doesn't restrict the polymorphic variants expressivity, the
syntax error on big variants easily gets unreadable. merd workarounds this by
reducing the expressivity of polymorphic variants (every value being a
polymorphic variant in merd): when a constructor is declared as belonging to a
type, it can't be anonymous anymore. In practice, it means you must either not
declare any type, or declare every type for the various constructors.

A second restriction occurs for undeclared constructors: they can't be applied
to different types. To allow this, the types must be given.

The goal of these restrictions is to enable the full power of polymorphic
variants without the bleeding edge.),

],

[ q(OCaml doesn't have record subtyping) =>

q(OCaml has both records and objects. The records do not allow subtyping. The
object's value is a record, but is only accessible in the object's methods.
This means using an object for having record subtyping is quite heavy-weight
(since you need to use accessors for reading and writing), but is possible.),

],

[
q(OCaml doesn't have objects subsumption) =>

q(This means you can't pass a compatible object to a function expecting an
ancestor ; you must down-cast to that ancestor first. For small functions,
this is not a big deal, since when unspecified, the type inference doesn't use
the name of the objects. Instead it keeps the name&types of the method used.
You get an open type and a kind of subsumption.

But there are case when things are not that nice. A typical example is to make
a list of different objects having a common ancestor. To create such alist you
have to down-cast to that common ancestor.),

],

[
q(Constructors are not functions) =>

q(You can't write "map Some l", you must eta-expand "Some" first: "map (fun e -> Some e) l"),
],

[
q(In OCaml, Partial application is semantically different from the eta-expanded version) =>

q(
ML partial application mix up two different beasts:
    <ul>
      <li><tt>let f1 x y = x + y</tt> which needs both arguments to compute something
      <li><tt>let f2 x = (print "f2 called" ; fun y -&gt; x + y)</tt> 
            which really produces a function using the first argument.
    </ul>
    The time of evalution is different, but the type signatures of <tt>f1</tt> and <tt>f2</tt> are
    the same.
    This forbids eta-expansion: <tt>f2 x</tt> is not equivalent to <tt>y -&gt; f2 x y</tt>
),

q(There is also the monomorphism restriction:),

pre(q(
let g1 f = f 1, f "1";;
let g2 =
  let doubles = List.map (fun e -> e,e) in
  doubles [1], doubles ["1"];;
)),

q(g1 and g2 are ill-typed. g1 can't be expressed in OCaml, and g2 must be written:),

pre(q(
let g2 =
  let doubles l = List.map (fun e -> e,e) l in
  doubles [1], doubles ["1"];;
)),

q(<a href="http://caml.inria.fr/FAQ/FAQ_EXPERT-eng.html#variables_de_types_faibles">more on this</a>),

],

[
q(Partially applied operators) =>

q("filter (> 1) list" is illegal in OCaml.
"filter ((>) 1) list" is allowed, but it's unreadable, since "(>) 1" means "fun x -> 1 > x" and not
"fun x -> x > 1"),

q(merd allows "(> 1)" which is "x -> x > 1" as expected (Haskell has the same feature)),
]
],

Haskell => [
[
 'merd is an imperative language, Haskell is not' => 
q(
Monads are a great thing when you want a tidy/explicit handling of the state.
But of course one needs to think things differently. A simple example is:
), pre(q(
* merd *********************************
do_with_env(doit,l,env,f) =
    r_env = env
    l' = l.doit(e -> (e', r_env) = f(e, r_env) ; e')
    l', r_env
* ocaml ********************************
let do_withenv doit f env l =
  let r_env = ref env in
  let l' = doit (fun e -> 
    let e', env' = f !r_env e in
    r_env := env' ; e'
  ) l in
  l', !r_env
)), q(
This can't be done in haskell without introducing state handling in "doit". So
disallowing state reduce expressivity. The advantage gain for haskell comes
from lazy evaluation, which notably simplifies iterators. For some kind of
programs, loosing imperativity is no big deal. Alas, it is not so for typical
scripting.
),
],
[
 'merd has subsumption on values, not only on classes' =>

 q(
It solves quite a few problem encountered in haskell. A typical example is the
Int vs Integer problem:
), pre(q(
mean l = sum l / length l
-- doesn't compile because
  -- length returns an Int
  -- "Fractional Int" doesn't exist (which is normal)

-- a solution is to define "length" with an open type ("sum" is not closed-world,
-- otherwise one couldn't use it on [Float])

-- length2 :: Num a => [b] -> a
length2 []     = 0
length2 (x:xs) = 1 + length2 xs

-- mean :: Fractional a => [a] -> a
mean l = sum l / length2 l
)),
q(
merd has no problem using an Int in a division. Subsumption will help it
transform in a larger type instancing Fractional.
) 

],

[
q(Haskell is plagued by the monomorphism restriction),

q("is_empty = (== [])" is ill-typed),

q(<a href="http://www.haskell.org/tutorial/pitfalls.html#sect12.3">more on this</a>),
],

[
 'merd has no curried vs uncurried functions' =>
 "compare merd's",
  pre('not ~ member?'), "and Haskell's", pre('
curry (not . uncurry elem)    or
(not.) . elem                 or
\x l -> not (elem x l)'),
],

$string_interpolation,

[
q(Partially applied operators) =>

q("filter (> 1) list" in Haskell is ok, so is "list.filter(> 1)" in merd (<a href="#OCaml">contrary to OCaml</a>)),

q(but you can still get weird thing in Haskell: "((>) 1)" is "\x -> 1 > x"
whereas in merd ">" can't be partially applied this way, you'll get a syntax
error. Another way to write it in merd is "(>)(,1)" which is "x -> (>)(x,1)"
which is also "x -> x > 1"),
], 

],


];


$\ = "\n";

print <<'EOF';
<html>
  <head>
    <title>merd vs other languages</title>
  </head>

<body text="#f5deb3" link="#f5de83" alink="#b3ae71" vlink="#b3ae71" bgcolor="#2f4f4f">

The goal of this document is to show the advantages of using merd over various
languages. If you have been beaten by one of the things below, you may be
happy to know it's fixed in merd.

<p>

<b>But</b> this doesn't imply than the language compared is worse than merd.
There are of course different choices and your mileage may vary. As Matz is saying: 

<blockquote>
Why should you switch to Ruby? If you are happy with Perl or Python, you
don't have to. But if you do feel there must be a better language, Ruby may be
your language of choice. Learning a new language is harmless. It gives you new
ideas and insights. You don't have to switch, just learn and try it. You may
find yourself comfortable enough with Ruby to decide to switch to it.
</blockquote>

You can also have a look at <a href="flaws.html">merd's Known Flaws</a>.

EOF


print "<h2>Summary</h2>";
print "<ul>";
foreach (group_by2(@$all)) {
    my ($name, $l) = @$_;
    print qq(<li><a href="#$name">$name</a>);
}
print "</ul>";

foreach (group_by2(@$all)) {
    my ($name, $l) = @$_;
    print qq(<hr><h2><a name="$name">merd vs $name</a></h2>);
    handle_ul(0, @$l);
}

print <<'EOF';
<hr>
<address><a href="mailto:pixel@merd.net">Pixel</a></address>
This document is licensed under <a href="http://www.gnu.org/copyleft/fdl.html">GFDL</a> (GNU Free Documentation License).
<p>Release: $Id: merd-vs-others.html.pl,v 1.14 2002/06/17 22:30:39 pixel_ Exp $

<p><A HREF="http://www.estat.com/getstats?serial=1400113423"><IMG SRC="http://perso.estat.com/cgi-bin/perso/1400113423?page=merd" BORDER=0></A>

</body>
</html>
EOF


sub handle_ul {
    my ($depth, @l) = @_;
    my $ul_opened;
    foreach (@l) {
	if (ref $_) {
	    $ul_opened ||= do { print "<ul>"; 1 };
	    print "<li>";
	    handle_ul($depth + 1, @$_);
	    print "<p>" if @$_ > 1 || $depth < 1;
	} else {
	    $ul_opened &&= do { print "</ul>"; 0 };
	    print html_quote($_);
	    print "<p>" if @l > 1;
	}
    }
    $ul_opened &&= do { print "</ul>"; 0 };
}

sub group_by2 {
    my @l;
    for (my $i = 0; $i < @_ ; $i += 2) {
	push @l, [ $_[$i], $_[$i+1] ];
    }
    @l;
}
sub pre {
    "<pre>" . html_quote($_[0]) . "</pre>";
}
sub html_quote {
    local $_ = $_[0];
    if (!/<pre>/ && !/<a href/ && !/<ul>/) {
	s/</&lt;/g;
	s/>/&gt;/g;
	s/\n\n/\n<p>\n/mg;
    }
    $_;
}
