val debug : bool
val during_type_inference : bool ref
val args : string list ref
val resolve_constraints :
  (Types.env ->
   Types.fromrewrite ->
   Types.fromrewrite ->
   (Types.fromrewrite * Types.fromrewrite) option * Types.env)
  ref
exception Not_compile_time
exception Parameter_number_mismatch of string
exception Interpreter_call of Types.fromrewrite
exception Interpreter_rew of Types.fromrewrite
val may_failwith : string -> 'a
val deref : Types.fromrewrite -> Types.fromrewrite
val create_closure : Types.env -> Types.fromrewrite -> Types.fromrewrite
val remap_locals_propa :
  Types.env -> int -> Types.fromrewrite -> Types.fromrewrite
val remap_locals : int -> Types.fromrewrite -> Types.fromrewrite
val rew_map_ref :
  (Types.fromrewrite -> Types.fromrewrite) ->
  Types.fromrewrite -> Types.fromrewrite
val debuginfo : string -> Types.fromrewrite -> unit
val sep2l_env :
  Types.env ->
  Types.fromrewrite ->
  (bool -> Types.env -> Types.fromrewrite list -> 'a) -> 'a
val func_env :
  Types.env ->
  Types.fromrewrite ->
  (Types.env -> Types.fromrewrite list -> Types.fromrewrite -> 'a) -> 'a
val sep2l_env_binary :
  Types.env ->
  Types.fromrewrite ->
  (bool -> Types.env -> Types.fromrewrite * Types.fromrewrite -> 'a) -> 'a
val unify : Types.env -> Types.fromrewrite * Types.fromrewrite -> bool
val resolve_overloading :
  Types.env ->
  Types.fromrewrite ->
  Types.fromrewrite ->
  Types.fromrewrite -> Types.fromrewrite list * Types.fromrewrite * Types.env
val reduce_seq :
  Types.env -> string -> Types.fromrewrite list -> Types.fromrewrite
val caml_defined :
  string -> Types.env -> Types.fromrewrite -> Types.fromrewrite
val call_func :
  Types.env ->
  Types.fromrewrite -> Types.env -> Types.fromrewrite -> Types.fromrewrite
val call :
  Types.env ->
  Types.fromrewrite ->
  Types.fromrewrite -> Types.fromrewrite -> Types.fromrewrite
val eval_including_func : Types.env -> Types.fromrewrite -> Types.fromrewrite
val eval_ : Types.env -> Types.fromrewrite -> Types.fromrewrite
val eval_val : Types.env -> Types.fromrewrite -> Types.fromrewrite
val eval_during_type_inference :
  Types.env -> Types.fromrewrite -> Types.fromrewrite
val eval_main : Types.env -> Types.fromrewrite -> Types.fromrewrite
