type 'a lattice = ('a * 'a bounds) list
and 'a bounds = { lower : 'a list; upper : 'a list; } 
val lower_than : ('a * 'a bounds) list -> 'a * 'a bounds -> 'a list
val upper_than : ('a * 'a bounds) list -> 'a * 'a bounds -> 'a list
val lower_bounds : ('a * 'b bounds) list -> 'a list
val upper_bounds : ('a * 'b bounds) list -> 'a list
val lower_bounds_ : ('a * 'a bounds) list -> 'a -> 'a list
val upper_bounds_ : ('a * 'a bounds) list -> 'a -> 'a list
val compute_bounds_ :
  ('a -> 'b -> int) ->
  ('a * 'a bounds) list ->
  'b -> [> `Already_in_lattice of 'a | `Bounds of 'a bounds]
val create : unit -> 'a list
val add_ :
  ('a -> 'a -> int) ->
  ('a * 'a bounds) list -> 'a -> 'a * ('a * 'a bounds) list
val add :
  ('a -> 'a -> int) -> ('a * 'a bounds) list -> 'a -> ('a * 'a bounds) list
val compute_bounds :
  ('a -> 'b -> int) -> ('a * 'a bounds) list -> 'b -> 'a bounds
val least_upper_than :
  ('a -> 'b -> int) -> ('a * 'a bounds) list -> 'b -> 'a list
val greatest_lower_than :
  ('a -> 'b -> int) -> ('a * 'a bounds) list -> 'b -> 'a list
val greatest_upper_than :
  ('a -> 'b -> int) -> ('a * 'a bounds) list -> 'b -> 'a list
val test : unit -> unit
