exception Found
exception No_match_found
exception Resolve_best_type of string
exception Type_greater of Types.fromrewrite * Types.fromrewrite
val debug : bool
val eval_some : Types.env -> Types.fromrewrite -> Types.fromrewrite option
val eval_type : Types.env -> Types.fromrewrite -> Types.fromrewrite
val eval_type_some :
  Types.env -> Types.fromrewrite -> Types.fromrewrite option
val eval_type_no_error : Types.env -> Types.fromrewrite -> Types.fromrewrite
val type_declare :
  Types.env -> Types.fromrewrite -> Types.fromrewrite -> bool * Types.env
val are_simple_paras : Types.fromrewrite list -> bool
val to_compile_time : Types.valtyp -> Types.fromrewrite
val to_run_time : Types.valtyp -> Types.fromrewrite * Types.fromrewrite
val valtyp2s : Types.valtyp -> string
val map_valtyp :
  (Types.fromrewrite -> Types.fromrewrite) ->
  (Types.fromrewrite -> Types.fromrewrite) -> Types.valtyp -> Types.valtyp
val iter_valtyp :
  (Types.fromrewrite -> 'a) ->
  (Types.fromrewrite -> 'a) -> Types.valtyp -> 'a
val eval_marked_val : Types.env -> Types.fromrewrite -> Types.fromrewrite
val set_var_typ :
  Types.env -> Types.fromrewrite -> Types.tconstraint -> Types.env
val var2lower_and_greater :
  Types.env ->
  Types.fromrewrite -> Types.fromrewrite option * Types.fromrewrite option
val add_var_typ :
  Types.env -> Types.fromrewrite -> Types.fromrewrite -> Types.env
val set_var_allt :
  Types.env ->
  Types.fromrewrite -> Types.fromrewrite -> Types.fromrewrite -> Types.env
val full_simplify :
  Types.env -> Types.fromrewrite -> Types.fromrewrite * Types.env
val full_simplify_ :
  bool -> Types.env -> Types.fromrewrite -> Types.fromrewrite * Types.env
val propagate_constr :
  Types.env ->
  Types.tconstraint -> Types.fromrewrite -> Types.tconstraint * Types.env
val propagate_var_constr : Types.env -> Types.fromrewrite -> Types.env
val propagate_stack : Types.env -> Types.env
val resolve_best_type_ :
  bool ->
  [> `Same | `Greater | `Greater_allt] ->
  [ `Used_as_function | `Unused | `Multi | `Once of Types.tinoutness] ->
  Types.env ->
  Types.fromrewrite ->
  Types.tconstraint -> Types.fromrewrite option * Types.env
val resolve_best_type :
  [> `Same | `Greater | `Greater_allt] ->
  [ `Used_as_function | `Unused | `Multi | `Once of Types.tinoutness] ->
  Types.env -> Types.fromrewrite -> Types.env
val resolve_best_type_keep_abstract :
  Types.env ->
  Types.fromrewrite -> (Types.fromrewrite * Types.fromrewrite) * Types.env
val resolve_aliased_vars : Types.env -> int list * Types.env
val resolve_local_vars_ :
  [> `Same | `Greater | `Greater_allt] ->
  Types.env -> Types.fromrewrite list -> Types.fromrewrite list -> Types.env
val resolve_local_vars :
  Types.env -> Types.fromrewrite list -> Types.fromrewrite list -> Types.env
val env_unpack_constr_raw :
  Types.env ->
  Types.fromrewrite ->
  (Types.fromrewrite * Types.env) * (int * Types.tconstr) list
val env_unpack_constr_ :
  Types.env ->
  Types.fromrewrite ->
  (Types.fromrewrite * Types.env) * (int * Types.tconstr) list
val env_unpack_constr :
  Types.env -> Types.fromrewrite -> Types.fromrewrite * Types.env
val cmppart_funcs :
  bool ->
  bool ->
  [> `Same | `Greater | `Greater_allt] ->
  Types.env ->
  Types.fromrewrite * Types.fromrewrite ->
  Types.fromrewrite option * Types.env
val cmppart_simplify :
  bool ->
  [> `Same | `Greater | `Greater_allt] ->
  (Types.env ->
   Types.fromrewrite ->
   Types.fromrewrite -> Types.fromrewrite option * Types.env) ->
  Types.env ->
  Types.fromrewrite * Types.fromrewrite ->
  Types.fromrewrite option * Types.env
val cmppart_is_same :
  bool ->
  [> `Same | `Greater | `Greater_allt] ->
  (Types.env ->
   Types.fromrewrite ->
   Types.fromrewrite -> Types.fromrewrite option * Types.env) ->
  Types.env ->
  Types.fromrewrite * Types.fromrewrite ->
  Types.fromrewrite option * Types.env
val cmppart_is_same_only :
  bool ->
  [> `Same | `Greater | `Greater_allt] ->
  (Types.env ->
   Types.fromrewrite ->
   Types.fromrewrite -> Types.fromrewrite option * Types.env) ->
  Types.env ->
  Types.fromrewrite * Types.fromrewrite ->
  Types.fromrewrite option * Types.env
val cmppart_is_greater_allt :
  bool ->
  [> `Same | `Greater | `Greater_allt] ->
  (Types.env ->
   Types.fromrewrite ->
   Types.fromrewrite -> Types.fromrewrite option * Types.env) ->
  Types.env ->
  Types.fromrewrite * Types.fromrewrite ->
  Types.fromrewrite option * Types.env
val cmppart_is_greater :
  bool ->
  [> `Same | `Greater | `Greater_allt] ->
  (Types.env ->
   Types.fromrewrite ->
   Types.fromrewrite -> Types.fromrewrite option * Types.env) ->
  Types.env ->
  Types.fromrewrite * Types.fromrewrite ->
  Types.fromrewrite option * Types.env
val cmppart2_is_greater :
  bool ->
  [> `Same | `Greater | `Greater_allt] ->
  (Types.env ->
   Types.fromrewrite ->
   Types.fromrewrite -> Types.fromrewrite option * Types.env) ->
  Types.env ->
  Types.fromrewrite * Types.fromrewrite ->
  Types.fromrewrite option * Types.env
val cmppart_ensure_same :
  bool ->
  [> `Same | `Greater | `Greater_allt] ->
  (Types.env ->
   Types.fromrewrite ->
   Types.fromrewrite -> Types.fromrewrite option * Types.env) ->
  Types.env ->
  Types.fromrewrite * Types.fromrewrite ->
  Types.fromrewrite option * Types.env
val cmppart_ensure_greater :
  bool ->
  [> `Same | `Greater | `Greater_allt] ->
  (Types.env ->
   Types.fromrewrite ->
   Types.fromrewrite -> Types.fromrewrite option * Types.env) ->
  Types.env ->
  Types.fromrewrite * Types.fromrewrite ->
  Types.fromrewrite option * Types.env
val cmppart2_ensure_greater :
  bool ->
  [> `Same | `Greater | `Greater_allt] ->
  (Types.env ->
   Types.fromrewrite ->
   Types.fromrewrite -> Types.fromrewrite option * Types.env) ->
  Types.env ->
  Types.fromrewrite * Types.fromrewrite ->
  Types.fromrewrite option * Types.env
val cmpparts_ensure :
  (([> `Same | `Greater | `Greater_allt] as 'a) *
   (bool ->
    'a ->
    (Types.env ->
     Types.fromrewrite ->
     Types.fromrewrite -> Types.fromrewrite option * Types.env) ->
    Types.env ->
    Types.fromrewrite * Types.fromrewrite ->
    Types.fromrewrite option * Types.env)
   list)
  list
val cmpparts_is :
  (([> `Same | `Greater | `Greater_allt] as 'a) *
   (bool ->
    'a ->
    (Types.env ->
     Types.fromrewrite ->
     Types.fromrewrite -> Types.fromrewrite option * Types.env) ->
    Types.env ->
    Types.fromrewrite * Types.fromrewrite ->
    Types.fromrewrite option * Types.env)
   list)
  list
val compute_cmppart :
  bool ->
  [> `Ensure | `Is] ->
  [> `Same | `Greater | `Greater_allt] ->
  Types.env ->
  Types.fromrewrite ->
  Types.fromrewrite -> Types.fromrewrite option * Types.env
val io_cmppart :
  bool ->
  bool ->
  [> `Ensure | `Is] ->
  [> `Same | `Greater | `Greater_allt] ->
  Types.env ->
  Types.fromrewrite ->
  Types.fromrewrite -> Types.fromrewrite option * Types.env
val option2bool_env :
  Types.fromrewrite option * Types.env -> bool * Types.env
val simple_is_same_ :
  Types.env -> Types.fromrewrite -> Types.fromrewrite -> bool * Types.env
val simple_is_greater_ :
  Types.env -> Types.fromrewrite -> Types.fromrewrite -> bool * Types.env
val ensure_same :
  Types.env ->
  Types.fromrewrite ->
  Types.fromrewrite -> Types.fromrewrite option * Types.env
val ensure_greater_ :
  Types.env ->
  Types.fromrewrite ->
  Types.fromrewrite -> Types.fromrewrite option * Types.env
val ensure_greater_allow_io :
  Types.env ->
  Types.fromrewrite ->
  Types.fromrewrite -> Types.fromrewrite option * Types.env
val simple_is_greater :
  Types.env -> Types.fromrewrite -> Types.fromrewrite -> bool
val func_is_greater :
  Types.env ->
  [> `Same | `Greater | `Greater_allt] ->
  Types.fromrewrite -> Types.fromrewrite -> bool
val ensure_same_or_greater_Var_exists :
  Types.env ->
  Types.fromrewrite ->
  Types.fromrewrite -> (Types.fromrewrite option * Types.env) * bool
val ensure_greater :
  Types.env -> Types.fromrewrite -> Types.fromrewrite -> Types.env
val ensure_greater_l_e :
  Types.env -> Types.fromrewrite list -> Types.fromrewrite -> Types.env
val ensure_greater_e_l :
  Types.env -> Types.fromrewrite -> Types.fromrewrite list -> Types.env
val ensure_greater_l_l :
  Types.env -> Types.fromrewrite list -> Types.fromrewrite list -> Types.env
val cooked_cmppart_ :
  (Types.env ->
   Types.fromrewrite ->
   Types.fromrewrite -> Types.fromrewrite option * Types.env) ->
  Types.env ->
  Types.fromrewrite ->
  Types.fromrewrite -> Types.fromrewrite option * Types.env
val cooked_cmppart :
  (Types.env ->
   Types.fromrewrite ->
   Types.fromrewrite -> Types.fromrewrite option * Types.env) ->
  Types.env -> Types.fromrewrite -> Types.fromrewrite -> Types.env
val cooked_ensure_greater :
  Types.env -> Types.fromrewrite -> Types.fromrewrite -> Types.env
val cooked_ensure_greater_io :
  Types.env -> Types.fromrewrite -> Types.fromrewrite -> Types.env
val func_have_common_subtype :
  Types.env -> Types.fromrewrite -> Types.fromrewrite -> bool
val alias_or_allt_paras : Types.env -> Types.fromrewrite -> Types.env
val infere_func :
  bool ->
  Types.fromrewrite option ->
  Types.env ->
  Types.fromrewrite option -> Types.fromrewrite -> Types.valtyp * Types.env
val infere_simple_type_call_noerror :
  Types.env ->
  Types.fromrewrite -> Types.fromrewrite -> Types.fromrewrite * Types.env
val infere_simple_type_call :
  Types.env ->
  Types.fromrewrite ->
  Types.fromrewrite ->
  Types.fromrewrite * Types.fromrewrite -> Types.fromrewrite * Types.env
val infere_call :
  bool ->
  Types.fromrewrite option ->
  Types.env ->
  Types.fromrewrite ->
  Types.fromrewrite -> Types.fromrewrite -> Types.valtyp * Types.env
val hack_for_semicolon :
  Types.env -> Types.fromrewrite -> Types.fromrewrite * Types.env
val infere_sepL_ed :
  Types.env ->
  string ->
  Types.fromrewrite list ->
  Types.fromrewrite * Types.fromrewrite list * Types.env
val infere :
  bool ->
  Types.fromrewrite option ->
  Types.env -> Types.fromrewrite -> Types.valtyp * Types.env
val infere_run_time :
  bool ->
  Types.fromrewrite option ->
  Types.env ->
  Types.fromrewrite -> (Types.fromrewrite * Types.fromrewrite) * Types.env
val rew2names_ :
  ((Types.fromrewrite * int) * Types.fromrewrite) list ->
  Types.env -> Types.fromrewrite -> Types.fromrewrite * Types.env
val get_type_vars :
  Types.env -> ((Types.fromrewrite * int) * Types.fromrewrite) list
val infere_main : Types.env -> Types.fromrewrite -> Types.valtyp * Types.env
val help_interpreter_resolving_constraints :
  Types.env ->
  Types.fromrewrite ->
  Types.fromrewrite ->
  (Types.fromrewrite * Types.fromrewrite) option * Types.env
